﻿using AutoMapper;
using MvcErrorHandling.DomainModel;
using MvcErrorHandling.DomainModel.ErrorLinksModel;
using MvcErrorHandling.Models.Home;

namespace MvcErrorHandling
{
    public class AutoMapperProfile : Profile
    {
        public override string ProfileName { get { return "ViewModel"; } }

        protected override void Configure()
        {
            CreateMap<ErrorConfiguration, ErrorConfigurationView>()
                .ForMember(x => x.ErrorTriggerLinkOpenMode, o => o.ResolveUsing(x => x.AppSettingsWriter.ErrorTriggerLinkOpenMode))
                .ForMember(x => x.ManualServerErrorHandlingMode, o => o.ResolveUsing(x => x.AppSettingsWriter.ManualServerErrorHandlingMode))
                .ForMember(x => x.TrySkipIisCustomErrorsMode, o => o.ResolveUsing(x => x.AppSettingsWriter.TrySkipIisCustomErrorsMode))
                .ForMember(x => x.ErrorPageRenderingMode, o => o.ResolveUsing(x => x.AppSettingsWriter.ErrorPageRenderingMode))
                .ForMember(x => x.ErrorPageExceptionsMode, o => o.ResolveUsing(x => x.AppSettingsWriter.ErrorPageExceptionsMode))
                .ForMember(x => x.RelaxedUrlToFileSystemMappingMode, o => o.ResolveUsing(x => x.HttpRuntime.RelaxedUrlToFileSystemMappingMode))
                .ForMember(x => x.ManualErrorsRenderingMode, o => o.ResolveUsing(x => x.AppSettingsWriter.ManualErrorsRenderingMode))
                .ForMember(x => x.ManualNotFoundErrorHandlingMode, o => o.ResolveUsing(x => x.AppSettingsWriter.ManualNotFoundErrorHandlingMode));

            CreateMap<ErrorConfigurationView, IndexViewModel>()
                .ForMember(x => x.FourHundredErrorLinks, o => o.ResolveUsing(x => ErrorLinkRepository.FourHundredErrorLinks))
                .ForMember(x => x.FiveHundredErrorLinks, o => o.ResolveUsing(x => ErrorLinkRepository.FiveHundredErrorLinks));

            CreateMap<IndexViewModel, ErrorConfigurationView>();
        }
    }
}