﻿using System;

namespace MvcErrorHandling.DomainModel.CustomErrorsModel
{
    public enum CustomErrorsMode
    {
        On,
        Off,
        [DefaultEnumValue]
        RemoteOnly
    }

    public static class CustomErrorsModeExtensions
    {
        public static CustomErrorsMode FromSystemCustomErrorsMode(this System.Web.Configuration.CustomErrorsMode mode)
        {
            switch (mode)
            {
                case System.Web.Configuration.CustomErrorsMode.RemoteOnly:
                    return CustomErrorsMode.RemoteOnly;
                case System.Web.Configuration.CustomErrorsMode.On:
                    return CustomErrorsMode.On;
                case System.Web.Configuration.CustomErrorsMode.Off:
                    return CustomErrorsMode.Off;
                default:
                    throw new ArgumentOutOfRangeException("mode");
            }
        }

        public static System.Web.Configuration.CustomErrorsMode ToSystemCustomErrorsMode(this CustomErrorsMode mode)
        {
            switch (mode)
            {
                case CustomErrorsMode.On:
                    return System.Web.Configuration.CustomErrorsMode.On;
                case CustomErrorsMode.Off:
                    return System.Web.Configuration.CustomErrorsMode.Off;
                case CustomErrorsMode.RemoteOnly:
                    return System.Web.Configuration.CustomErrorsMode.RemoteOnly;
                default:
                    throw new ArgumentOutOfRangeException("mode");
            }
        }
    }
}