﻿using System;

namespace MvcErrorHandling.DomainModel.CustomErrorsModel
{
    public enum CustomErrorsRedirectMode
    {
        [DefaultEnumValue]
        ResponseRedirect,
        ResponseRewrite
    }

    public static class CustomErrorsRedirectModeExtensions
    {
        public static CustomErrorsRedirectMode FromSystemCustomErrorsRedirectMode(
            this System.Web.Configuration.CustomErrorsRedirectMode mode)
        {
            switch (mode)
            {
                case System.Web.Configuration.CustomErrorsRedirectMode.ResponseRedirect:
                    return CustomErrorsRedirectMode.ResponseRedirect;
                case System.Web.Configuration.CustomErrorsRedirectMode.ResponseRewrite:
                    return CustomErrorsRedirectMode.ResponseRewrite;
                default:
                    throw new ArgumentOutOfRangeException("mode");
            }
        }

        public static System.Web.Configuration.CustomErrorsRedirectMode ToSystemCustomErrorsRedirectMode(
            this CustomErrorsRedirectMode mode)
        {
            switch (mode)
            {
                case CustomErrorsRedirectMode.ResponseRedirect:
                    return System.Web.Configuration.CustomErrorsRedirectMode.ResponseRedirect;
                case CustomErrorsRedirectMode.ResponseRewrite:
                    return System.Web.Configuration.CustomErrorsRedirectMode.ResponseRewrite;
                default:
                    throw new ArgumentOutOfRangeException("mode");
            }
        }
    }
}