﻿using System;
using System.Linq;

namespace MvcErrorHandling.DomainModel
{
    public static class EnumHelpers
    {
        public static TEnum GetDefaultEnumValue<TEnum>()
        {
            var enumType = typeof(TEnum);

            foreach (var memberInfo in enumType.GetMembers())
            {
                if (memberInfo.GetCustomAttributes(typeof(DefaultEnumValueAttribute), false).Any())
                {
                    return (TEnum)Enum.Parse(enumType, memberInfo.Name, true);
                }
            }

            throw new Exception(string.Format("Enum {0} has no member with default value attribute.", typeof(TEnum)));
        }
    }
}