﻿using MvcErrorHandling.DomainModel.AppSettingsModel;
using MvcErrorHandling.DomainModel.CustomErrorsModel;
using MvcErrorHandling.DomainModel.HttpErrorsModel;
using MvcErrorHandling.DomainModel.HttpRuntimeModel;

namespace MvcErrorHandling.DomainModel
{
    public class ErrorConfigurationView
    {
        public CustomErrorsMode CustomErrorsMode { get; set; }
        public CustomErrorsRedirectMode CustomErrorsRedirectMode { get; set; }
        public CustomErrorsRedirectType CustomErrorsNotFoundErrorRedirect { get; set; }
        public CustomErrorsRedirectType CustomErrorsForbiddenErrorRedirect { get; set; }
        public CustomErrorsRedirectType CustomErrorsServerErrorRedirect { get; set; }

        public RelaxedUrlToFileSystemMappingMode RelaxedUrlToFileSystemMappingMode { get; set; }

        public HttpErrorsMode HttpErrorsMode { get; set; }
        public HttpErrorsExistingResponseMode HttpErrorsExistingResponseMode { get; set; }
        public HttpErrorsRedirectType HttpErrorsNotFoundErrorRedirect { get; set; }
        public HttpErrorsRedirectType HttpErrorsForbiddenErrorRedirect { get; set; }
        public HttpErrorsRedirectType HttpErrorsServerErrorRedirect { get; set; }

        public ErrorTriggerLinkOpenMode ErrorTriggerLinkOpenMode { get; set; }
        public ManualServerErrorHandlingMode ManualServerErrorHandlingMode { get; set; }
        public TrySkipIisCustomErrorsMode TrySkipIisCustomErrorsMode { get; set; }
        public ErrorPageRenderingMode ErrorPageRenderingMode { get; set; }
        public ErrorPageExceptionsMode ErrorPageExceptionsMode { get; set; }
        public ManualNotFoundErrorHandlingMode ManualNotFoundErrorHandlingMode { get; set; }
        public ManualErrorsRenderingMode ManualErrorsRenderingMode { get; set; }
    }
}