﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;

namespace MvcErrorHandling.DomainModel.ErrorLinksModel
{
    public class ErrorLinkGroup
    {
        private readonly List<ErrorLink> _errorLinks;

        public string Name { get; private set; }

        public ReadOnlyCollection<ErrorLink> ErrorLinks { get { return _errorLinks.AsReadOnly(); } }

        public ErrorLinkGroup(string name, List<ErrorLink> errorLinks)
        {
            if (name == null) throw new ArgumentNullException("name");
            if (errorLinks == null) throw new ArgumentNullException("errorLinks");

            Name = name;
            _errorLinks = errorLinks;
        }
    }
}