﻿using System;
using System.Web.Configuration;

namespace MvcErrorHandling.DomainModel.HttpRuntimeModel
{
    public class HttpRuntimeSettings
    {
        private readonly HttpRuntimeSection _httpRuntimeSection;

        public RelaxedUrlToFileSystemMappingMode RelaxedUrlToFileSystemMappingMode { get; private set; }

        public HttpRuntimeSettings(HttpRuntimeSection httpRuntimeSection)
        {
            if (httpRuntimeSection == null) throw new ArgumentNullException("httpRuntimeSection");

            _httpRuntimeSection = httpRuntimeSection;
        }

        public void ReadSection()
        {
            RelaxedUrlToFileSystemMappingMode = _httpRuntimeSection.RelaxedUrlToFileSystemMapping
                ? RelaxedUrlToFileSystemMappingMode.Relaxed
                : RelaxedUrlToFileSystemMappingMode.NotRelaxed;
        }

        public void UpdateSection()
        {
            UpdateSection(EnumHelpers.GetDefaultEnumValue<RelaxedUrlToFileSystemMappingMode>());
        }

        public void UpdateSection(RelaxedUrlToFileSystemMappingMode relaxedUrlToFileSystemMappingMode)
        {
            RelaxedUrlToFileSystemMappingMode = relaxedUrlToFileSystemMappingMode;

            _httpRuntimeSection.RelaxedUrlToFileSystemMapping = 
                RelaxedUrlToFileSystemMappingMode == RelaxedUrlToFileSystemMappingMode.Relaxed;
        }
    }
}