﻿using System.ComponentModel.DataAnnotations;
using MvcErrorHandling.DomainModel.AppSettingsModel;
using MvcErrorHandling.DomainModel.CustomErrorsModel;
using MvcErrorHandling.DomainModel.ErrorLinksModel;
using MvcErrorHandling.DomainModel.HttpErrorsModel;
using MvcErrorHandling.DomainModel.HttpRuntimeModel;

namespace MvcErrorHandling.Models.Home
{
    public class IndexViewModel
    {
        // Custom Errors

        [Display(Name = "Mode")]
        public CustomErrorsMode CustomErrorsMode { get; set; }

        [Display(Name = "Redirect mode")]
        public CustomErrorsRedirectMode CustomErrorsRedirectMode { get; set; }

        [Display(Name = "404 Not Found redirect")]
        public CustomErrorsRedirectType CustomErrorsNotFoundErrorRedirect { get; set; }

        [Display(Name = "403 Forbidden redirect")]
        public CustomErrorsRedirectType CustomErrorsForbiddenErrorRedirect { get; set; }

        [Display(Name = "500 Server Error redirect")]
        public CustomErrorsRedirectType CustomErrorsServerErrorRedirect { get; set; }

        // HTTP Errors

        [Display(Name = "Mode")]
        public HttpErrorsMode HttpErrorsMode { get; set; }

        [Display(Name = "Existing response")]
        public HttpErrorsExistingResponseMode HttpErrorsExistingResponseMode { get; set; }

        [Display(Name = "404 Not Found redirect")]
        public HttpErrorsRedirectType HttpErrorsNotFoundErrorRedirect { get; set; }

        [Display(Name = "403 Forbidden redirect")]
        public HttpErrorsRedirectType HttpErrorsForbiddenErrorRedirect { get; set; }

        [Display(Name = "500 Server Error redirect")]
        public HttpErrorsRedirectType HttpErrorsServerErrorRedirect { get; set; }

        // Manual Errors

        [Display(Name = "404 error handling")]
        public ManualNotFoundErrorHandlingMode ManualNotFoundErrorHandlingMode { get; set; }

        [Display(Name = "500 error handling")]
        public ManualServerErrorHandlingMode ManualServerErrorHandlingMode { get; set; }

        [Display(Name = "App error handler response")]
        public ManualErrorsRenderingMode ManualErrorsRenderingMode { get; set; }

        // Miscellaneous

        [Display(Name = "Link open mode")]
        public ErrorTriggerLinkOpenMode ErrorTriggerLinkOpenMode { get; set; }

        [Display(Name = "Skip IIS errors mode")]
        public TrySkipIisCustomErrorsMode TrySkipIisCustomErrorsMode { get; set; }

        [Display(Name = "Error page rendering")]
        public ErrorPageRenderingMode ErrorPageRenderingMode { get; set; }

        [Display(Name = "Error page exceptions")]
        public ErrorPageExceptionsMode ErrorPageExceptionsMode { get; set; }

        [Display(Name = "Relaxed URL mappings")]
        public RelaxedUrlToFileSystemMappingMode RelaxedUrlToFileSystemMappingMode { get; set; }

        // Error Links

        public ErrorLinkGroup FourHundredErrorLinks { get; set; }

        public ErrorLinkGroup FiveHundredErrorLinks { get; set; }
    }
}