﻿using System.Configuration;
using System.Web.Mvc;
using MvcErrorHandling.DomainModel.AppSettingsModel;

namespace MvcErrorHandling.MvcHelpers
{
    /// <summary>
    /// Derives from <see cref="HandleErrorAttribute"/> to allow it to be skippable and to allow for other adjustments.
    /// </summary>
    public class SkippableHandleErrorAttribute : HandleErrorAttribute
    {
        public override void OnException(ExceptionContext filterContext)
        {
            if (!ConfigurationManager.AppSettings.Include(ManualServerErrorHandlingMode.HandleErrorAttribute))
            {
                return;
            }

            base.OnException(filterContext);

            filterContext.HttpContext.Response.TrySkipIisCustomErrors = ConfigurationManager.AppSettings.Include(
                TrySkipIisCustomErrorsMode.Skip);
        }
    }
}