﻿using System.Configuration;
using System.Web;
using System.Web.Routing;
using MvcErrorHandling.DomainModel.AppSettingsModel;

namespace MvcErrorHandling.MvcHelpers
{
    /// <summary>
    /// An Mvc route constraint that allows a route to be conditionally skipped based on a given app setting.
    /// </summary>
    public class SkippableRouteConstraint : IRouteConstraint
    {
        public bool Match(
            HttpContextBase httpContext,
            Route route,
            string parameterName,
            RouteValueDictionary values,
            RouteDirection routeDirection)
        {
            return ConfigurationManager.AppSettings.Include(ManualNotFoundErrorHandlingMode.WithinMvcFramework)
                || ConfigurationManager.AppSettings.Include(ManualNotFoundErrorHandlingMode.ApplicationErrorHandler);
        }
    }
}