﻿// Bind ajax form submission functionality to the update settings and reset settings submit buttons.

$(function () {

    var options = {
        target: '#update-settings-form-result',
        error: function (xhr, textStatus, errorThrown) {
            alert('Failed to alter Web.config');
        },
        complete: function (xhr, textStatus) {
            $('button').removeClass('disabled');
            $('button').removeAttr('disabled');
            $('#settings-form-loading').hide();
        }
    };

    var submitEventHandler = function (event) {
        var $this = $(this);
        $('#settings-form-loading').show();
        $('button').addClass('disabled');
        $('button').attr('disabled', 'disabled');
        $this.ajaxSubmit(options);
        event.preventDefault();
    };

    $('#update-settings-form').bind('submit', submitEventHandler);
    $('#reset-settings-form').bind('submit', submitEventHandler);

});

// Enable interception of error link clicks so they can target the iframe if required.

$(function () {
    $('#error-links-section').find('a').not('.ajax-error-link').not('.post-link')
        .bind('click', function (event) {
            if ($('#ErrorTriggerLinkOpenMode').val() == 'Frame') {
                var $this = $(this);
                $this.attr('target', 'linktargetframe');
                var url = $this.attr('href');

                $.ajax({
                    type: "GET",
                    url: url,
                    complete: function (xhr, textStatus) {
                        $('#frame-section').show();

                        // Set the status code from the ajax page request.
                        $('#http-status-code').val(xhr.status);

                        // If I just set the html of the frame to be the html returned by the ajax page request, 
                        // the styling is not quite right. Getting round this by making a second request.

                        top.linktargetframe.location.href = url;
                    }
                });

                event.preventDefault();
            } else {
                $('#frame-section').hide();
                $(this).attr('target', '_blank');
            }
        });
});

// Intercept ajax error link clicks.

$(function () {
    $('#error-links-section').find('a.ajax-error-link').bind('click', function (event) {
        var $this = $(this);
        var url = $this.attr('href');

        $.getJSON(url, function (data) {
            alert('Failed to get an error response.');
        })
        .error(function (xhr, textStatus, errorThrown) {
            alert('Error thrown: ' + errorThrown);
            alert('Response text: ' + xhr.responseText);
        });

        event.preventDefault();
    });
});

// Intercept POST error link clicks.

$(function () {
    $('#error-links-section').find('a.post-link').bind('click', function (event) {
        var $this = $(this);
        var url = $this.attr('href');
        if ($('#ErrorTriggerLinkOpenMode').val() == 'Frame') {
            $('#frame-section').show();
            $('#http-status-code').val("Can't get for this link");
            window.frames['linktargetframe'].document.body.innerHTML =
                '<form action="' + url + '" method="post" id="post-link-form" style="display:none"></form>';
            window.frames['linktargetframe'].document.forms["post-link-form"].submit();
        } else {
            $('#frame-section').hide();
            var $form = $('#post-link-form');
            $form.attr('action', url);
            $form.submit();
        }
        event.preventDefault();
    });
});